      PROGRAM CHECK

********************************************************************
*                                                                  *
*                     Author: A. BECK                              *
*                     2003-05-26                                   *
*                                                                  *
********************************************************************

      USE GRIB_API

      INTEGER I,J,K,L
      INTEGER INDE,LUNIT,LENGHT,levtotal,LEV,LEVMIN,LEVMAX

 
      CHARACTER*1 YOPER
      integer ierr

      integer maxl, maxb, mlevel, levout, mnauf
      real rlo0, rlo1, rla0, rla1

      INTEGER MAUF, MANF,meta,metadiff
      
      integer npar,ipar,igrib
      parameter(npar=15)
      integer ireq(npar),isum(npar)

      character*4 ccheck(npar)
      integer icheck(npar)

      data ccheck /"T","U","V","Q","LNSP","DETA","LSP","CP","SSHF",
     1     "SSR","EWSS","NSSS","OMEG","OMD","PTEN"/      
      data ireq /130,131,132,133,134,77,142,143,146,176,180,181,
     *135,001,158/         
      data isum /  1,  1,  1,  1, -1,  1, -1, -1, -1, -1, -1, -1,  1, 
     *1, -1/      
   

      NAMELIST /NAMGEN/
     1            MAXL, MAXB,
     2            MLEVEL,LEVOUT,LEVMIN,LEVMAX,
     3            MNAUF,
     4            RLO0, RLO1, RLA0, RLA1,
     5            MOMEGA,MOMEGADIFF,MGAUSS,MSMOOTH,META,METADIFF

      call posnam (4,'NAMGEN')
      read (4,NAMGEN)

      MAUF=INT(360.*(REAL(MAXL)-1.)/(RLO1-RLO0))

      MANF=INT(REAL(MAUF)/360.*(360.+RLO0)+1.)


*******************************************************************
*     GRIB STUFF *
*******************************************************************


      icheck(:) = 0

*
* OPENING OF UNBLOCKED GRIB FILE
*
        call grib_open_file(LUNIT,'fort.15','r',iret)
        call grib_count_in_file(LUNIT,n)

        do i=1,n
          call grib_new_from_file(LUNIT,igrib, iret)
          call grib_get(igrib,"paramId",ipar)
 
          do j=1,npar
            if(ireq(j) == ipar) icheck(j)=icheck(j)+isum(j)
          enddo
        enddo
        call grib_close_file(LUNIT)

*
* OPENING OF UNBLOCKED GRIB FILE
*
      IF(MOMEGADIFF .NE. 0 .OR. MOMEGA .NE. 0) THEN
        call grib_open_file(LUNIT,'fort.25','r',iret)
        call grib_count_in_file(LUNIT,n)

        do i=1,n
          call grib_new_from_file(LUNIT,igrib, iret)
          call grib_get(igrib,"paramId",ipar)
 
          do j=1,npar
            if(ireq(j) == ipar) icheck(j)=icheck(j)+isum(j)
          enddo
        enddo
        call grib_close_file(LUNIT)
      ENDIF

 310  IERR = 0

*
* OPENING OF ETADOT FILE
*
      IF(METADIFF .NE. 0 .AND. META .NE. 0) THEN
        call grib_open_file(LUNIT,'fort.26','r',iret)
        call grib_count_in_file(LUNIT,n)

        do i=1,n
          call grib_new_from_file(LUNIT,igrib, iret)
          call grib_get(igrib,"paramId",ipar)
 
          do j=1,npar
!            if(ireq(j) == ipar) icheck(j)=icheck(j)+1
          enddo
        enddo
        call grib_close_file(LUNIT)
      ENDIF

 410  IERR = 0

      print*,npar,momegadiff,momega
      do i = 1, npar-2*(1-MOMEGADIFF)-(1-MOMEGA)
         if (icheck(i) .eq. -1) then
             write (*,9905) ccheck(i), abs(icheck(i))
         elseif (icheck(i) .ge. 1 .and.
     * icheck(i) .eq. levmax-levmin+1) then
            write (*,9900) ccheck(i), icheck(i), levmax-levmin+1
         else
            write (*,9910) ccheck(i), icheck(i)
            IERR = IERR + 1
         endif
      enddo

      if (IERR .eq. 0) then
         open(12,file='CHECK.SUCCESS')
         write (12,*) 'CHECK FINISHED SUCCESSFULLY'
         close(12)
      else
         print*, 'CHECK FAILED !!!'
         STOP
      endif

 9900 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' expected: ',I3.2,' OK')

 9905 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' OK')

 9910 FORMAT (' >> CHECK: parameter, nr level(s): ',
     2        A5,2x,I3.2,' FAILED')

      END
      
