      subroutine dapoly(xfeld,sfeld,nx,ny,jpoly)
********************************************************************
*                                                                  *
*                     Author: P. JAMES                             *
*                     2000-03-29                                   *
*                     adapted: A. BECK                             *
*                     2003-06-01                                   *
*                                                                  *
********************************************************************
*                                                                  *
* DESCRIPTION: This program interpolates deaccumulated fluxes of   *
* an ECMWF model FG field using a cubic polynomial solution which  *
* conserves the integrals of the fluxes within each timespan       *
* The interpolated values are output at the central point of the 4 *
* accumulation timespans                                           *
*                                                                  *
********************************************************************

      integer i,j
      real xfeld(nx,ny,jpoly),sfeld(nx,ny)
      real pya,pyb,pyc,pyd,xa,xb,xc,xd

      do 400 i=1,nx
      do 400 j=1,ny
         xa=xfeld(i,j,1)
         xb=xfeld(i,j,2)
         xc=xfeld(i,j,3)
         xd=xfeld(i,j,4)
         pya=(xd-xa+3.*(xb-xc))/6.
         pyb=(xc+xa)/2.-xb-9.*pya/2.
         pyc=xb-xa-7.*pya/2.-2.*pyb
         pyd=xa-pya/4.-pyb/3.-pyc/2.
         sfeld(i,j)=8.*pya+4.*pyb+2.*pyc+pyd
400   continue

      return
      end

