	MODULE FTRAFO

	CONTAINS

C Poissonloeser im Phasenraum
	SUBROUTINE POISSON(DIV,POT,MNAUF,NK)
	
	IMPLICIT NONE
	
	INTEGER M,N,K,MNAUF,NK,INDEX
	
	REAL	DIV(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL	POT(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	
	REAL ERAD,FAC
	
	ERAD=6371000.0

	DO 2 K = 1,NK
		DO 2 M = 0,MNAUF
			INDEX = (M*(M+1))/2
			DO 2 N = M,MNAUF
				INDEX=INDEX+N
				IF(N.GT.0) THEN		
			FAC=FLOAT(N)*FLOAT(N+1)/ERAD/ERAD
			POT(2*INDEX,K)=-DIV(2*INDEX,K)/FAC
			POT(2*INDEX+1,K)=-DIV(2*INDEX+1,K)/FAC
				ELSE
					POT(2*INDEX,K)=0.0
					POT(2*INDEX+1,K)=0.0
				ENDIF
2	CONTINUE

	RETURN
	END SUBROUTINE POISSON
			
C
C	Implementierung der spektralen Transformationsmethode unter Verwendung
C	des reduzierten Gauss'schen Gitters
C	
C Berechnung der scale winds aus Vorticity und Divergenz
C uebergibt man in XMN die Divergenz, so wird der divergente Anteil des
C Windes (XPHI=Ud,XPHI=Vd) zurueckgegeben, uebergibt man die Vorticity, so 
C erhaelt man den rotationellen Wind (XLAM=Vrot,XPHI=-Urot).
C Summiert man beide, erhaelt man den gesamten Scale wind
C	GWSAVE ist ein Hilfsfeld fuer die FFT
C	P enthaelt die assoziierten Legendrepolynome, H deren Ableitung
C	MLAT enthaelt die Anzahl der Gitterpunkte pro Breitenkreis
C	MNAUF gibt die spektrale Aufloesung an,
C	NI = Anzahl der Gauss'schen Gitterpunkte pro Flaeche
C	NJ = Anzahl der Gauss'schen Breiten,
C	NK = Anzahl der Niveaus
 
	SUBROUTINE VDTOUV(XMN,XLAM,XPHI,GWSAVE,P,H,MLAT,MNAUF,NI,NJ,NK)


	USE PHTOGR

	IMPLICIT NONE
	INTEGER   J,K,M,N,NI,NJ,NK,MNAUF,GGIND,LL,LLP,LLH,LLS,LLPS,LLHS
	INTEGER		MLAT(NJ)
	REAL     	UFOUC(0:MAXAUF),MUFOUC(0:MAXAUF)
	REAL 			VFOUC(0:MAXAUF),MVFOUC(0:MAXAUF)
	REAL			XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL		P(0:(MNAUF+3)*(MNAUF+4)/2,NJ/2)
	REAL		H(0:(MNAUF+2)*(MNAUF+3)/2)
	REAL			XLAM(NI,NK),XPHI(NI,NK)
	REAL			GWSAVE(8*NJ+15,NJ/2)
	REAL 		ERAD,SCR,SCI,ACR,ACI,MUSCR,MUSCI,MUACR,MUACI
	REAL	  FAC(0:1000),RT,IT
	
	ERAD = 6371000.D0
	
	FAC(0)=0.D0
	DO 12 N=1,MNAUF
	  FAC(N)=-ERAD/DBLE(N)/DBLE(N+1)
12	CONTINUE
	GGIND=0
	DO 4 J = 1,NJ/2
	 CALL DPLGND(MNAUF,P(0,J),H)
	 DO 3 K = 1,NK
	  LL=0
	  LLP=0
	  LLH=0
	  DO 2 M = 0,MNAUF
	   SCR=0.D0
	   SCI=0.D0
	   ACR=0.D0
	   ACI=0.D0
	   MUSCR=0.D0
	   MUSCI=0.D0
	   MUACR=0.D0
	   MUACI=0.D0
	   LLS=LL
	   LLPS=LLP
	   LLHS=LLH
	   IF(2*M+1.LT.MLAT(J)) THEN
	      DO 1 N = M,MNAUF,2
	       RT=XMN(2*LL,K)*FAC(N)
	       IT=XMN(2*LL+1,K)*FAC(N)
	       SCR =SCR+ RT*P(LLP,J)
	       SCI =SCI+ IT*P(LLP,J)
	       MUACR =MUACR+ RT*H(LLH)
	       MUACI =MUACI+ IT*H(LLH)
	       LL=LL+2
	       LLP=LLP+2
	       LLH=LLH+2
 1	      CONTINUE
	      LL=LLS+1
	      LLP=LLPS+1
	      LLH=LLHS+1
	      DO 11 N = M+1,MNAUF,2
	       RT=XMN(2*LL,K)*FAC(N)
	       IT=XMN(2*LL+1,K)*FAC(N)
	       ACR =ACR+ RT*P(LLP,J)
	       ACI =ACI+ IT*P(LLP,J)
	       MUSCR =MUSCR+ RT*H(LLH)
	       MUSCI =MUSCI+ IT*H(LLH)
	       LL=LL+2
	       LLP=LLP+2
	       LLH=LLH+2
 11	      CONTINUE
	   ENDIF
	   LL=LLS+(MNAUF-M+1)
	   LLP=LLPS+(MNAUF-M+3)
	   LLH=LLHS+(MNAUF-M+2)
	   
	   
	   UFOUC(2*M)=-M*(SCI-ACI)
	   UFOUC(2*M+1)=M*(SCR-ACR)
	   VFOUC(2*M)=-M*(SCI+ACI)
	   VFOUC(2*M+1)=M*(SCR+ACR)
	   
	   MUFOUC(2*M)=-(MUSCR-MUACR)
	   MUFOUC(2*M+1)=-(MUSCI-MUACI)
	   MVFOUC(2*M)=-(MUSCR+MUACR)
	   MVFOUC(2*M+1)=-(MUSCI+MUACI)
 2	  CONTINUE
			
			CALL FOURTR(VFOUC,XLAM(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL FOURTR(UFOUC,XLAM(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
			CALL FOURTR(MVFOUC,XPHI(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL FOURTR(MUFOUC,XPHI(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
3		CONTINUE
		GGIND=GGIND+MLAT(J)
4	CONTINUE

	RETURN
	END SUBROUTINE VDTOUV

C Berechnung des Gradienten eines Skalars aus dem Feld des
C	Skalars XMN im Phasenraum. Zurueckgegeben werden die Felder der
C	Komponenten des horizontalen Gradienten XLAM,XPHI auf dem Gauss'schen Gitter.
C	GWSAVE ist ein Hilfsfeld fuer die FFT
C	P enthaelt die assoziierten Legendrepolynome, H deren Ableitung
C	MLAT enthaelt die Anzahl der Gitterpunkte pro Breitenkreis
C	MNAUF gibt die spektrale Aufloesung an, 
C	NI = Anzahl der Gauss'schen Gitterpunkte,
C	NJ = Anzahl der Gauss'schen Breiten,
C	NK = Anzahl der Niveaus
 
	SUBROUTINE PHGRAD(XMN,XLAM,XPHI,GWSAVE,P,H,MLAT,
     *MNAUF,NI,NJ,NK)

	USE PHTOGR
	IMPLICIT NONE
	INTEGER   J,K,M,N,NI,NJ,NK,MNAUF,GGIND,LL,LLP,LLH,LLS,LLPS,LLHS
	INTEGER		MLAT(NJ)
	REAL     	UFOUC(0:MAXAUF),MUFOUC(0:MAXAUF)
	REAL 			VFOUC(0:MAXAUF),MVFOUC(0:MAXAUF)
	REAL			XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL		P(0:(MNAUF+3)*(MNAUF+4)/2,NJ/2)
	REAL		H(0:(MNAUF+2)*(MNAUF+3)/2)
	REAL			XLAM(NI,NK),XPHI(NI,NK)
	REAL			GWSAVE(8*NJ+15,NJ/2)
	REAL      ERAD
	REAL 		SCR,SCI,ACR,ACI,MUSCR,MUSCI,MUACR,MUACI,RT,IT
	
	ERAD = 6371000.0
	
	GGIND=0
	DO 4 J = 1,NJ/2
	 CALL DPLGND(MNAUF,P(0,J),H)
	 DO 3 K = 1,NK
	  LL=0
	  LLP=0
	  LLH=0
	  DO 2 M = 0,MNAUF
	   SCR=0.D0
	   SCI=0.D0
	   ACR=0.D0
	   ACI=0.D0
	   MUSCR=0.D0
	   MUSCI=0.D0
	   MUACR=0.D0
	   MUACI=0.D0
	   LLS=LL
	   LLPS=LLP
	   LLHS=LLH
	   IF(2*M+1.LT.MLAT(J)) THEN
	      DO 1 N = M,MNAUF,2
	       RT=XMN(2*LL,K)
	       IT=XMN(2*LL+1,K)
	       SCR =SCR+ RT*P(LLP,J)
	       SCI =SCI+ IT*P(LLP,J)
	       MUACR =MUACR+RT*H(LLH)
	       MUACI =MUACI+ IT*H(LLH)
	       LL=LL+2
	       LLP=LLP+2
	       LLH=LLH+2
 1	      CONTINUE
	      LL=LLS+1
	      LLP=LLPS+1
	      LLH=LLHS+1
	      DO 11 N = M+1,MNAUF,2
	       RT=XMN(2*LL,K)
	       IT=XMN(2*LL+1,K)
	       ACR =ACR+ RT*P(LLP,J)
	       ACI =ACI+ IT*P(LLP,J)
	       MUSCR =MUSCR+ RT*H(LLH)
	       MUSCI =MUSCI+ IT*H(LLH)
	       LL=LL+2
	       LLP=LLP+2
	       LLH=LLH+2
 11	      CONTINUE
	   ENDIF
          LL=LLS+(MNAUF-M+1)
          LLP=LLPS+(MNAUF-M+3)
          LLH=LLHS+(MNAUF-M+2)

				UFOUC(2*M)=-M*(SCI-ACI)/ERAD
				UFOUC(2*M+1)=M*(SCR-ACR)/ERAD
				VFOUC(2*M)=-M*(SCI+ACI)/ERAD
				VFOUC(2*M+1)=M*(SCR+ACR)/ERAD

				MUFOUC(2*M)=-(MUSCR-MUACR)/ERAD
				MUFOUC(2*M+1)=-(MUSCI-MUACI)/ERAD
				MVFOUC(2*M)=-(MUSCR+MUACR)/ERAD
				MVFOUC(2*M+1)=-(MUSCI+MUACI)/ERAD
2			CONTINUE
			
			CALL FOURTR(VFOUC,XLAM(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL FOURTR(UFOUC,XLAM(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
			CALL FOURTR(MVFOUC,XPHI(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL FOURTR(MUFOUC,XPHI(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
3		CONTINUE
		GGIND=GGIND+MLAT(J)
4	CONTINUE


	RETURN
	END SUBROUTINE PHGRAD

C Berechnung des Gradienten eines Skalars aus dem Feld des
C	Skalars XMN im Phasenraum. Zurueckgegeben werden die Felder der
C	Komponenten des horizontalen Gradienten XLAM,XPHI auf dem Gauss'schen Gitter.
C	GWSAVE ist ein Hilfsfeld fuer die FFT
C	P enthaelt die assoziierten Legendrepolynome, H deren Ableitung
C	MLAT enthaelt die Anzahl der Gitterpunkte pro Breitenkreis
C	MNAUF gibt die spektrale Aufloesung an, 
C	NI = Anzahl der Gauss'schen Gitterpunkte,
C	NJ = Anzahl der Gauss'schen Breiten,
C	NK = Anzahl der Niveaus
 
	SUBROUTINE PHGRACUT(XMN,XLAM,XPHI,GWSAVE,P,H,MAUF,
     *MNAUF,NI,NJ,MANF,NK)

	USE PHTOGR
	IMPLICIT NONE
	INTEGER   J,K,M,N,NI,NJ,NK,MNAUF,GGIND,LL,LLP,LLH,LLS,LLPS,LLHS
	INTEGER		MAUF,MANF,I
	REAL     	UFOUC(0:MAXAUF),MUFOUC(0:MAXAUF)
	REAL 			VFOUC(0:MAXAUF),MVFOUC(0:MAXAUF)
	REAL			XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL		P(0:(MNAUF+3)*(MNAUF+4)/2,NJ)
	REAL		H(0:(MNAUF+2)*(MNAUF+3)/2)
	REAL			XLAM(NI,NJ,NK),XPHI(NI,NJ,NK)
	REAL			HLAM(MAXAUF,2),HPHI(MAXAUF,2)
	REAL			GWSAVE(4*MAUF+15)
	REAL      ERAD
	REAL 		SCR,SCI,ACR,ACI,MUSCR,MUSCI,MUACR,MUACI,RT,IT
	
	ERAD = 6371000.0
	
	GGIND=0
	DO 4 J = 1,NJ
	 CALL DPLGND(MNAUF,P(0,J),H)
	 DO 3 K = 1,NK
	  LL=0
	  LLP=0
	  LLH=0
	  DO 2 M = 0,MNAUF
	   SCR=0.D0
	   SCI=0.D0
	   ACR=0.D0
	   ACI=0.D0
	   MUSCR=0.D0
	   MUSCI=0.D0
	   MUACR=0.D0
	   MUACI=0.D0
	   LLS=LL
	   LLPS=LLP
	   LLHS=LLH
	   IF(2*M+1.LT.MAUF) THEN
	      DO 1 N = M,MNAUF,2
	       RT=XMN(2*LL,K)
	       IT=XMN(2*LL+1,K)
	       SCR =SCR+ RT*P(LLP,J)
	       SCI =SCI+ IT*P(LLP,J)
	       MUACR =MUACR+RT*H(LLH)
	       MUACI =MUACI+ IT*H(LLH)
	       LL=LL+2
	       LLP=LLP+2
	       LLH=LLH+2
 1	      CONTINUE
	      LL=LLS+1
	      LLP=LLPS+1
	      LLH=LLHS+1
	      DO 11 N = M+1,MNAUF,2
	       RT=XMN(2*LL,K)
	       IT=XMN(2*LL+1,K)
	       ACR =ACR+ RT*P(LLP,J)
	       ACI =ACI+ IT*P(LLP,J)
	       MUSCR =MUSCR+ RT*H(LLH)
	       MUSCI =MUSCI+ IT*H(LLH)
	       LL=LL+2
	       LLP=LLP+2
	       LLH=LLH+2
 11	      CONTINUE
	   ENDIF
          LL=LLS+(MNAUF-M+1)
          LLP=LLPS+(MNAUF-M+3)
          LLH=LLHS+(MNAUF-M+2)

				UFOUC(2*M)=-M*(SCI-ACI)/ERAD
				UFOUC(2*M+1)=M*(SCR-ACR)/ERAD
				VFOUC(2*M)=-M*(SCI+ACI)/ERAD
				VFOUC(2*M+1)=M*(SCR+ACR)/ERAD

				MUFOUC(2*M)=-(MUSCR-MUACR)/ERAD
				MUFOUC(2*M+1)=-(MUSCI-MUACI)/ERAD
				MVFOUC(2*M)=-(MUSCR+MUACR)/ERAD
				MVFOUC(2*M+1)=-(MUSCI+MUACI)/ERAD
2			CONTINUE
			
			CALL FOURTR(VFOUC,HLAM(1,1),
     *GWSAVE,MNAUF,MAUF,1)
!			CALL FOURTR(UFOUC,HLAM(1,2),
!     *GWSAVE,MNAUF,MAUF,1)
			
			CALL FOURTR(MVFOUC,HPHI(1,1),
     *GWSAVE,MNAUF,MAUF,1)
!			CALL FOURTR(MUFOUC,HPHI(1,2),
!     *GWSAVE,MNAUF,MAUF,1)
			
            DO 6 I=0,NI-1
                  IF(MANF+I.LE. MAUF) THEN
                    XLAM(I+1,J,K)=HLAM(MANF+I,1)
                    XPHI(I+1,J,K)=HPHI(MANF+I,1)
                  ELSE
                    XLAM(I+1,J,K)=HLAM(MANF-MAUF+I,1)
                    XPHI(I+1,J,K)=HPHI(MANF-MAUF+I,1)
                  ENDIF
    6   CONTINUE
3		CONTINUE
		GGIND=GGIND+MAUF
4	CONTINUE

	RETURN
	END SUBROUTINE PHGRACUT

C Berechnung des Gradienten eines Skalars aus dem Feld des
C	Skalars XMN im Phasenraum. Zurueckgegeben werden die Felder der
C	Komponenten des horizontalen Gradienten XLAM,XPHI auf dem Gauss'schen Gitter.
C	GWSAVE ist ein Hilfsfeld fuer die FFT
C	P enthaelt die assoziierten Legendrepolynome, H deren Ableitung
C	MLAT enthaelt die Anzahl der Gitterpunkte pro Breitenkreis
C	MNAUF gibt die spektrale Aufloesung an, 
C	NI = Anzahl der Gauss'schen Gitterpunkte,
C	NJ = Anzahl der Gauss'schen Breiten,
C	NK = Anzahl der Niveaus
 
	SUBROUTINE PHGRDO(XMN,XLAM,XPHI,GWSAVE,P,H,MLAT,
     *MNAUF,NI,NJ,NK)

	USE PHTOGR
	IMPLICIT NONE
	INTEGER   J,K,M,N,NI,NJ,NK,MNAUF,INDEX,GGIND
	INTEGER		MLAT(NJ)
	REAL     	UFOUC(0:MAXAUF),MUFOUC(0:MAXAUF)
	REAL 			VFOUC(0:MAXAUF),MVFOUC(0:MAXAUF)
	REAL			XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL		P(0:(MNAUF+3)*(MNAUF+4)/2,NJ/2)
	REAL		H(0:(MNAUF+2)*(MNAUF+3)/2)
	REAL			XLAM(NI,NK),XPHI(NI,NK)
	REAL		GWSAVE(8*NJ+15,NJ/2)
	REAL     ERAD
	REAL 		SCR,SCI,ACR,ACI,MUSCR,MUSCI,MUACR,MUACI
	
	ERAD = 6371000.D0
	
	GGIND=0
	DO 4 J = 1,NJ/2
	 CALL DPLGND(MNAUF,P(0,J),H)
	 DO 3 K = 1,NK
	  DO 2 M = 0,MNAUF
	   INDEX = (M*(M+1))/2
	   SCR=0.D0
	   SCI=0.D0
	   ACR=0.D0
	   ACI=0.D0
	   MUSCR=0.D0
	   MUSCI=0.D0
	   MUACR=0.D0
	   MUACI=0.D0
	   IF(2*M+1.LT.MLAT(J)) THEN
	      DO 1 N = M,MNAUF
	       INDEX =INDEX+N
	       IF (MOD(N-M,2).EQ.0) THEN
		  SCR =SCR+ DBLE(XMN(2*INDEX,K))*P(INDEX,J)
		  SCI =SCI+ DBLE(XMN(2*INDEX+1,K))*P(INDEX,J)
		  MUACR =MUACR+ DBLE(XMN(2*INDEX,K))*H(INDEX)
		  MUACI =MUACI+ DBLE(XMN(2*INDEX+1,K))*H(INDEX)
	       ELSE
		  ACR =ACR+ DBLE(XMN(2*INDEX,K))*P(INDEX,J)
		  ACI =ACI+ DBLE(XMN(2*INDEX+1,K))*P(INDEX,J)
		  MUSCR =MUSCR+ DBLE(XMN(2*INDEX,K))*H(INDEX)
		  MUSCI =MUSCI+ DBLE(XMN(2*INDEX+1,K))*H(INDEX)
	       ENDIF
 1	      CONTINUE
	   ENDIF
	   
	   UFOUC(2*M)=-M*(SCI-ACI)/ERAD
	   UFOUC(2*M+1)=M*(SCR-ACR)/ERAD
	   VFOUC(2*M)=-M*(SCI+ACI)/ERAD
	   VFOUC(2*M+1)=M*(SCR+ACR)/ERAD
	   
	   MUFOUC(2*M)=-(MUSCR-MUACR)/ERAD
	   MUFOUC(2*M+1)=-(MUSCI-MUACI)/ERAD
	   MVFOUC(2*M)=-(MUSCR+MUACR)/ERAD
	   MVFOUC(2*M+1)=-(MUSCI+MUACI)/ERAD
 2	  CONTINUE
	  
			CALL DFOURTR(VFOUC,XLAM(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL DFOURTR(UFOUC,XLAM(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
			CALL DFOURTR(MVFOUC,XPHI(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL DFOURTR(MUFOUC,XPHI(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
3		CONTINUE
		GGIND=GGIND+MLAT(J)
4	CONTINUE

	RETURN
	END SUBROUTINE PHGRDO

C Berechnung der Divergenz aus dem Windfeld (U,V)
C	im Phasenraum. Zurueckgegeben werden die Felder der
C	Komponenten des horizontalen Gradienten XLAM,XPHI auf dem Gauss'schen Gitter.
C	GWSAVE ist ein Hilfsfeld fuer die FFT
C	P enthaelt die assoziierten Legendrepolynome, H deren Ableitung
C	MLAT enthaelt die Anzahl der Gitterpunkte pro Breitenkreis
C	MNAUF gibt die spektrale Aufloesung an, 
C	NI = Anzahl der Gauss'schen Gitterpunkte,
C	NJ = Anzahl der Gauss'schen Breiten,
C	NK = Anzahl der Niveaus
C Beachte, dass das Windfeld eine um 1 erhoehte Aufloesung in mu-Richtung hat.
 
	SUBROUTINE PHGRA214(XMN,XLAM,XPHI,GWSAVE,P,H,MLAT,
     *MNAUF,NI,NJ,NK)

	USE PHTOGR
	IMPLICIT NONE
	INTEGER   J,K,M,N,NI,NJ,NK,MNAUF,INDEX,GGIND
	INTEGER		MLAT(NJ)
	REAL     	UFOUC(0:MAXAUF),MUFOUC(0:MAXAUF)
	REAL 			VFOUC(0:MAXAUF),MVFOUC(0:MAXAUF)
	REAL			XMN(0:(MNAUF+2)*(MNAUF+3)-1,NK)
	REAL		P(0:(MNAUF+3)*(MNAUF+4)/2,NJ/2)
	REAL		H(0:(MNAUF+2)*(MNAUF+3)/2)
	REAL			XLAM(NI,NK),XPHI(NI,NK)
	REAL			GWSAVE(8*NJ+15,NJ/2)
	REAL      ERAD
	REAL 		SCR,SCI,ACR,ACI,MUSCR,MUSCI,MUACR,MUACI
	
	ERAD = 6371000.0
	
	GGIND=0
	DO 4 J = 1,NJ/2
	 CALL DPLGND(MNAUF,P(0,J),H)
	 DO 3 K = 1,NK
	  DO 2 M = 0,MNAUF
	   INDEX = (M*(M+1))/2
	   SCR=0.D0
	   SCI=0.D0
	   ACR=0.D0
	   ACI=0.D0
	   MUSCR=0.D0
	   MUSCI=0.D0
	   MUACR=0.D0
	   MUACI=0.D0
	   IF(2*M+1.LT.MLAT(J)) THEN
	      DO 1 N = M,MNAUF+1
	       INDEX =INDEX+N
	       IF (MOD(N-M,2).EQ.0) THEN
		  SCR =SCR+ XMN(2*INDEX,K)*P(INDEX,J)
		  SCI =SCI+ XMN(2*INDEX+1,K)*P(INDEX,J)
		  MUACR =MUACR+ XMN(2*INDEX,K)*H(INDEX)
		  MUACI =MUACI+ XMN(2*INDEX+1,K)*H(INDEX)
	       ELSE
		  ACR =ACR+ XMN(2*INDEX,K)*P(INDEX,J)
		  ACI =ACI+ XMN(2*INDEX+1,K)*P(INDEX,J)
		  MUSCR =MUSCR+ XMN(2*INDEX,K)*H(INDEX)
		  MUSCI =MUSCI+ XMN(2*INDEX+1,K)*H(INDEX)
	       ENDIF
 1	      CONTINUE
	   ENDIF
	   
	   UFOUC(2*M)=-M*(SCI-ACI)/ERAD
	   UFOUC(2*M+1)=M*(SCR-ACR)/ERAD
	   VFOUC(2*M)=-M*(SCI+ACI)/ERAD
	   VFOUC(2*M+1)=M*(SCR+ACR)/ERAD
	   
	   MUFOUC(2*M)=-(MUSCR-MUACR)/ERAD
	   MUFOUC(2*M+1)=-(MUSCI-MUACI)/ERAD
	   MVFOUC(2*M)=-(MUSCR+MUACR)/ERAD
	   MVFOUC(2*M+1)=-(MUSCI+MUACI)/ERAD
 2	  CONTINUE
	  
			CALL FOURTR(VFOUC,XLAM(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL FOURTR(UFOUC,XLAM(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
			CALL FOURTR(MVFOUC,XPHI(GGIND+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			CALL FOURTR(MUFOUC,XPHI(NI-GGIND-MLAT(J)+1,K),
     *GWSAVE(:,J),MNAUF,MLAT(J),1)
			
3		CONTINUE
		GGIND=GGIND+MLAT(J)
4	CONTINUE

	RETURN
	END SUBROUTINE PHGRA214


C	VADV berechnet die Vertikaladvektion.
C	PS ist der Bodendruck,
C E ist das Skalar, das advehiert wird,
C	X ist die Vertikalgeschwindigkeit in Hybridkoordinaten
C	Die Bedeutung der Arraygroessen steht in fconst.h

	SUBROUTINE VADV(PS,E,X,XADV,MLAT,NGI,NGJ,MKK)
	
	IMPLICIT NONE
	
#include <fconst.h>
	
	INTEGER K,L
	INTEGER MLAT(NGJ)

	REAL PS(NGI),E(NGI,MKK),X(NGI,MKK),XADV(NGI,MKK)
	REAL DP,UFAC,OFAC,A(MKK+1),B(MKK+1)

	DO 1 K=1,MKK
	  IF(K.EQ.1) THEN 
	    UFAC=0.
	  ELSE
	    UFAC=1.0
	  ENDIF
	  IF(K.EQ.MKK) THEN 
	    OFAC=0.
	  ELSE
	    OFAC=1.0
	  ENDIF
		DO 1 L=1,NGI
			DP=A(K+1)-A(K)+(B(K+1)-B(K))*PS(L)
		XADV(L,K)=0.5/DP*(OFAC*E(L,K)*(X(L,K+1)-X(L,K))+
     *UFAC*E(L,K-1)*(X(L,K)-X(L,K-1)))
1	CONTINUE

	RETURN
	END SUBROUTINE VADV
	
C	HADV berechnet die Horizontaladvektion.
C	U,V ist das horizontale Windfeld,
C	TMN ist die Temperatur im Phasenraum
C	GWSAVE ist ein Hilfsfeld fuer die FFT
C	P enthaelt die assoziierten Legendrepolynome, H deren Ableitung
C	GBREITE ist das Feld der Gauss'schen Breiten,
C	THADV das Ergebnis, HILF ein Hilfsarray fuer den meridionalen Gradienten
C	Die Bedeutung der Arraygroessen steht in fconst.h
				
	SUBROUTINE HADV(U,V,TMN,GWSAVE,P,H,GBREITE,HILF1,HILF2,MLAT,NGI
     *	 ,NGJ,MKK,MM)
	
	IMPLICIT NONE
	
#include <fconst.h>
	
	INTEGER I,J,K,L,MLAT(NGJ)
	
	REAL U(NGI,MKK),V(NGI,MKK)
	REAL TMN(0:(MM+1)*(MM+2)-1,MKK)
	REAL HILF1(NGI,MKK),HILF2(NGI,MKK)
	REAL GWSAVE(8*NGJ+15,NGJ/2)
	REAL P(0:(MM+3)*(MM+4)/2,NGJ/2)
	REAL H(0:(MM+2)*(MM+3)/2)
	REAL GBREITE(NGJ),MU
	
	CALL PHGRAD(TMN,HILF1,HILF2,GWSAVE,P,H,MLAT,MM,NGI,NGJ,MKK)
	DO 1 K=1,MKK
		L=0
		DO 1 J=1,NGJ
			MU=1.0-GBREITE(J)*GBREITE(J)
			DO 1 I=1,MLAT(J)
			  L=L+1
		HILF1(L,K)=(U(L,K)*HILF1(L,K)+V(L,K)*HILF2(L,K))/MU
1			CONTINUE

	RETURN
	END SUBROUTINE HADV

C	ETAECONV berechnet die Vertikalgeschwindigkeit im Hybridkoordinatensystem
C	und den Energiekonversionsterm.
C	PS ist der Bodendruck,
C	DPSDL,DPSDM sind die Komponenten des Gradienten des Logarithmus des
C	Bodendrucks
C	DIV,U,V sind die horizontale Divergenz und das horizontale Windfeld
C	BREITE ist das Feld der Gauss'schen Breiten
C	ETA ist die Vertikalgeschwindigkeit,
C	Die Energiekonversion wird in DIV zurueckgegeben
C	Die Bedeutung der Arraygroessen steht in fconst.h

	SUBROUTINE ETAECONV(PS,DPSDL,DPSDM,DIV,U,V,T,BREITE,E,MLAT,A,B
     * 	 ,NGI,NGJ,MKK)
				
	IMPLICIT NONE
	
#include <fconst.h>
	
	INTEGER I,J,K,L,MLAT(NGJ)
	
	REAL PS(NGI),DPSDL(NGI),DPSDM(NGI),E(NGI,MKK)
	REAL DIV(NGI,MKK),U(NGI,MKK),V(NGI,MKK),T(NGI,MKK),A(MKK),B(MKK)
	REAL BREITE(NGJ)
	
	REAL DIVT1,DIVT2,POB,PUN,DPSDT,DP,SUM,LOG2,ALPH,LOGDP,X,Y,BR
	REAL DIVT3(33)
	
	LOG2=LOG(2.0)
	L=0
	DO 4 J=1,NGJ
	 BR=1.0/(1.0-BREITE(J)*BREITE(J))
	 DO 3 I=1,MLAT(J)
	  L=L+1
	  DIVT1=0.0
	  DIVT2=0.0
	  DIVT3(1)=0.0
	  SUM=0.0
	  DO 1 K=1,MKK
	   POB=A(K)+B(K)*PS(L)
	   PUN=A(K+1)+B(K+1)*PS(L)
	   DP=PUN-POB
	   
	   IF(K.EQ.1) THEN
	      ALPH=LOG2
	      LOGDP=0.0
	   ELSE
	      LOGDP=LOG(PUN/POB)
	      ALPH=1.0-(POB/DP)*LOGDP
	   ENDIF
	   
	   Y=PS(L)*(U(L,K)*DPSDL(L)+V(L,K)*DPSDM(L))*BR
	   X=(B(K+1)-B(K))*Y
	   
	   DIVT1=DIVT1+DIV(L,K)*DP			
	   DIVT2=DIVT2+X
     
     		DIVT3(K+1)=DIV(L,K)*DP+X
     		DIV(L,K)=-DIVT1-DIVT2
     		SUM=SUM+DIVT3(K)
     		
     		E(L,K)=(LOGDP*SUM+ALPH*DIVT3(K+1))/DP
     		
     		IF(K.GT.1) THEN
     		E(L,K)=E(L,K)-Y/DP*((B(K+1)-B(K))+(A(K+1)*B(K)
     *-A(K)*B(K+1))/DP*LOGDP)
     		ELSE
     			E(L,K)=E(L,K)-DP*X
     		ENDIF
     		E(L,K)=E(L,K)*T(L,K)*KAP

1			CONTINUE

			PS(L)=-DIVT1-DIVT2
3		CONTINUE
4	CONTINUE
	DO 2 K=1,MKK
		DO 2 L=1,NGI
			DIV(L,K)=DIV(L,K)-PS(L)*B(K+1)
2	CONTINUE
	RETURN
	END SUBROUTINE ETAECONV
	
C	ETAECONV berechnet die Vertikalgeschwindigkeit im Hybridkoordinatensystem
C	und den Energiekonversionsterm.
C	PS ist der Bodendruck,
C	DPSDL,DPSDM sind die Komponenten des Gradienten des Logarithmus des
C	Bodendrucks
C	DIV,U,V sind die horizontale Divergenz und das horizontale Windfeld
C	BREITE ist das Feld der Gauss'schen Breiten
C	ETA ist die Vertikalgeschwindigkeit,
C	Die Energiekonversion wird in DIV zurueckgegeben
C	Die Bedeutung der Arraygroessen steht in fconst.h

	SUBROUTINE ETAECQ(PS,DPSDL,DPSDM,DIV,U,V,T,Q,BREITE,E,MLAT,A,B
     *	 ,NGI,NGJ,MKK)
				
	IMPLICIT NONE
	
#include <fconst.h>
	
	INTEGER I,J,K,L,MLAT(NGJ)
	
	REAL PS(NGI),DPSDL(NGI),DPSDM(NGI),E(NGI,MKK),A(MKK+1),B(MKK+1)
	REAL DIV(NGI,MKK),U(NGI,MKK),V(NGI,MKK),T(NGI,MKK),Q(NGI,MKK)
	REAL BREITE(NGJ)
	
	REAL DIVT1,DIVT2,POB,PUN,DPSDT,DP,SUM,LOG2,ALPH,LOGDP,X,Y,BR
	REAL DIVT3(33),VZ,VZ2
	
	VZ=461.51/287.05-1.0
	VZ2=1870.0/1005.46-1.0
	LOG2=LOG(2.0)

	DO 22 K=1,MKK
		DO 22 L=1,NGI
		Q(L,K)=T(L,K)*(1.0+VZ*Q(L,K))*KAP/(1.0+VZ2*Q(L,K))
22	CONTINUE

	L=0
	DO 4 J=1,NGJ
	 BR=1.0/(1.0-BREITE(J)*BREITE(J))
	 DO 3 I=1,MLAT(J)
	  L=L+1
	  DIVT1=0.0
	  DIVT2=0.0
	  DIVT3(1)=0.0
	  SUM=0.0
	  DO 1 K=1,MKK
	   POB=A(K)+B(K)*PS(L)
	   PUN=A(K+1)+B(K+1)*PS(L)
	   DP=PUN-POB
	   
	   IF(K.EQ.1) THEN
	      ALPH=LOG2
	      LOGDP=0.0
	   ELSE
	      LOGDP=LOG(PUN/POB)
	      ALPH=1.0-(POB/DP)*LOGDP
	   ENDIF
	   
	   Y=PS(L)*(U(L,K)*DPSDL(L)+V(L,K)*DPSDM(L))*BR
	   X=(B(K+1)-B(K))*Y
	   
	   DIVT1=DIVT1+DIV(L,K)*DP			
	   DIVT2=DIVT2+X
	   
	        DIVT3(K+1)=DIV(L,K)*DP+X
     		DIV(L,K)=-DIVT1-DIVT2
     		SUM=SUM+DIVT3(K)
     		
     		E(L,K)=(LOGDP*SUM+ALPH*DIVT3(K+1))/DP
     		
     		IF(K.GT.1) THEN
     		E(L,K)=E(L,K)-Y/DP*((B(K+1)-B(K))+(A(K+1)*B(K)
     *-A(K)*B(K+1))/DP*LOGDP)
     		ELSE
     			E(L,K)=E(L,K)-DP*X
     		ENDIF
     		E(L,K)=E(L,K)*Q(L,K)

1			CONTINUE

			PS(L)=-DIVT1-DIVT2
3		CONTINUE
4	CONTINUE
	DO 2 K=1,MKK
		DO 2 L=1,NGI
			DIV(L,K)=DIV(L,K)-PS(L)*B(K+1)
2	CONTINUE
	RETURN
	END SUBROUTINE ETAECQ
	
	SUBROUTINE PHGRPH(XMN,XLAM,XPHI,MNAUF,NK)

********************************************************************
*                                                                  *
*                     Author: L. HAIMBERGER                        *
*                     2000-12-11                                   *
*                     adapted: A. BECK                             *
*                     2003-05-11                                   *
*                                                                  *
********************************************************************

	IMPLICIT NONE
	
	INTEGER MNAUF,NK,K,M,N
	INTEGER INDEX,INDEXV,INDEXN

	REAL XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL XLAM(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL XPHI(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	
	REAL ERAD
	
	REAL EPS,EPS1
	
	ERAD= 6371000.0
	
	DO 3 K=1,NK
		DO 2 M = 0,MNAUF
			INDEX = (M*(M+1))/2
			DO 1 N = M,MNAUF
			  INDEXV=INDEX
				INDEX = INDEX+N
				INDEXN=INDEX+1+N
				EPS=SQRT(FLOAT(N*N-M*M)/FLOAT(4*N*N-1))
				EPS1=SQRT(FLOAT((N+1)*(N+1)-M*M)/FLOAT(4*(N+1)*(N+1)-1))
				IF(N.LE.MNAUF) THEN
					XLAM(2*INDEX,K) = -M*XMN(2*INDEX+1,K)/ERAD
					XLAM(2*INDEX+1,K) = M*XMN(2*INDEX,K)/ERAD
				ENDIF
				IF(N.LT.MNAUF) THEN
					 XPHI(2*INDEX,K) = -((N-1)*EPS*XMN(2*INDEXV,K)-
     *(N+2)*EPS1*XMN(2*INDEXN,K))/ERAD
					 XPHI(2*INDEX+1,K) = -((N-1)*EPS*XMN(2*INDEXV+1,K)-
     *(N+2)*EPS1*XMN(2*INDEXN+1,K))/ERAD
				ELSE
					 XPHI(2*INDEX,K) = 
     *-((N-1)*EPS*XMN(2*INDEXV,K))/ERAD
					 XPHI(2*INDEX+1,K) = 
     *-((N-1)*EPS*XMN(2*INDEXV+1,K))/ERAD
				ENDIF
1			CONTINUE
2		CONTINUE
3	CONTINUE
	RETURN
	END SUBROUTINE PHGRPH
	
	SUBROUTINE PHGRPF(XMN,XLAM,XPHI,MNAUF,NK)

********************************************************************
*                                                                  *
*                     Author: L. HAIMBERGER                        *
*                     2000-12-11                                   *
*                     adapted: A. BECK                             *
*                     2003-05-11                                   *
*                                                                  *
********************************************************************

	IMPLICIT NONE
	
	INTEGER MNAUF,NK,K,M,N
	INTEGER INDEX,INDEXV,INDEXN,LL,LLS

	REAL XMN(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL XLAM(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	REAL XPHI(0:(MNAUF+1)*(MNAUF+2)-1,NK)
	
	REAL ERAD
	
	REAL EPS,EPS1
	
	ERAD= 6371000.0
	
	DO 3 K=1,NK
                LL=0
		DO 2 M = 0,MNAUF
			LLS=LL
			DO 1 N = M,MNAUF
			   EPS=SQRT(FLOAT(N*N-M*M)/FLOAT(4*N*N-1))
			   EPS1=SQRT(FLOAT((N+1)*(N+1)-M*M)/FLOAT(4*(N+1)*(N+1)-1))
			   XLAM(2*LL,K) = -M*XMN(2*LL+1,K)/ERAD
			   XLAM(2*LL+1,K) = M*XMN(2*LL,K)/ERAD

                           IF(N .NE. M) THEN
				IF(N .LT. MNAUF) THEN
					 XPHI(2*LL,K) = -((N+1)*EPS*XMN(2*(LL-1),K)-
     *(N)*EPS1*XMN(2*(LL+1),K))/ERAD
					 XPHI(2*LL+1,K) = -((N+1)*EPS*XMN(2*(LL-1)+1,K)-
     *(N)*EPS1*XMN(2*(LL+1)+1,K))/ERAD
				ELSE
					 XPHI(2*LL,K) = 
     *-((N+1)*EPS*XMN(2*(LL-1),K))/ERAD
					 XPHI(2*LL+1,K) = 
     *-((N+1)*EPS*XMN(2*(LL-1)+1,K))/ERAD
				ENDIF
                            ELSE
                              XPHI(2*LL,K)=0.0
                              XPHI(2*LL+1,K)=0.0
                            ENDIF
                            LL=LL+1
1			CONTINUE
                        LLS=LLS+(MNAUF-M+1)
2		CONTINUE
3	CONTINUE
	RETURN
	END SUBROUTINE PHGRPF
	
	SUBROUTINE CONTGL(PS,DPSDL,DPSDM,DIV,U,V,BREITE,ETA,
     *MLAT,A,B,NI,NJ,NK)
				
	IMPLICIT NONE
	
	INTEGER NI,NJ,NK,I,J,K,MLAT(NJ),L
	
	REAL A(NK+1),B(NK+1)
	REAL PS(NI),DPSDL(NI),DPSDM(NI)
	REAL DIV(NI,NK),U(NI,NK),V(NI,NK),ETA(NI,NK)
	REAL BREITE(NJ)
	
	REAL DIVT1,DIVT2,POB,PUN,DPSDT,COSB
	
        L=0
	DO 4 J=1,NJ
		COSB=(1.0-BREITE(J)*BREITE(J))
		DO 3 I=1,MLAT(J)
                        L=L+1
			DIVT1=0.0
			DIVT2=0.0
			DO 1 K=1,NK
				POB=A(K)+B(K)*PS(L)
				PUN=A(K+1)+B(K+1)*PS(L)
				
				DIVT1=DIVT1+DIV(L,K)*(PUN-POB)
				DIVT2=DIVT2+(B(K+1)-B(K))*PS(L)*
     *(U(L,K)*DPSDL(L)+V(L,K)*DPSDM(L))/COSB
     
     		ETA(L,K)=-DIVT1-DIVT2
1			CONTINUE

			DPSDT=(-DIVT1-DIVT2)/PS(L)
			
			DO 2 K=1,NK
				ETA(L,K)=ETA(L,K)-DPSDT*B(K+1)*PS(L)
2			CONTINUE
			PS(L)=DPSDT*PS(L)
3		CONTINUE
4	CONTINUE
	RETURN
	END SUBROUTINE CONTGL
	
C	OMEGA berechnet omega im Hybridkoordinatensystem
C	PS ist der Bodendruck,
C	DPSDL,DPSDM sind die Komponenten des Gradienten des Logarithmus des
C	Bodendrucks
C	DIV,U,V sind die horizontale Divergenz und das horizontale Windfeld
C	BREITE ist das Feld der Gauss'schen Breiten
C	E ist omega,
C	Die Bedeutung der Arraygroessen steht in fconst.h

	SUBROUTINE OMEGA(PS,DPSDL,DPSDM,DIV,U,V,BREITE,E,MLAT,A,B,NGI
     *	 ,NGJ,MKK) 
				
	IMPLICIT NONE
	
#include <fconst.h>
	
	INTEGER I,J,K,L,MLAT(NGJ)
	
	REAL PS(NGI),DPSDL(NGI),DPSDM(NGI),A(MKK+1),B(MKK+1)
	REAL DIV(NGI,MKK),U(NGI,MKK),V(NGI,MKK),E(NGI,MKK)
	REAL BREITE(NGJ)
	
	REAL DIVT1,DIVT2,POB,PUN,DP,X,Y,COSB
	REAL DIVT3(MKK+2)
	
	L=0
	DO 4 J=1,NGJ
		COSB=(1.0-BREITE(J)*BREITE(J))
		DO 3 I=1,MLAT(J)
			L=L+1
			DIVT1=0.0
			DIVT2=0.0
			DIVT3(1)=0.0
			DO 1 K=1,MKK
				POB=A(K)+B(K)*PS(L)
				PUN=A(K+1)+B(K+1)*PS(L)
				DP=PUN-POB
				
		Y=PS(L)*(U(L,K)*DPSDL(L)+V(L,K)*DPSDM(L))/COSB
     		IF(K.LT.3) THEN
     		X=0.0
     		ELSE
				X=(B(K+1)-B(K))*Y
				ENDIF

				DIVT1=DIVT1+DIV(L,K)*DP			
				DIVT2=DIVT2+X
     
     		DIVT3(K+1)=-DIVT1-DIVT2
     		
     		IF(K.GT.1) THEN
				E(L,K) = 0.5*(POB+PUN)/DP*Y*
     *((B(K+1)-B(K))+(A(K+1)*B(K)-A(K)*B(K+1))/
     *DP*LOG(PUN/POB))
				ELSE
					E(L,K) = 0.0
				ENDIF
								
			E(L,K) = E(L,K)+0.5*(DIVT3(K)+DIVT3(K+1))

1			CONTINUE
3		CONTINUE
4	CONTINUE
	RETURN
	END SUBROUTINE OMEGA
	
	END MODULE FTRAFO
