      MODULE GAUSS
      CONTAINS

      SUBROUTINE ETAGAUSS(Z,WSAVE
     *,BREITE,T,U,V,ETAD,OM,PS,
     * MAUF,MAXB,MAXL,MANF,MNAUF,MLEVEL,MSMOOTH)

      USE RWGRIB
      USE PHTOGR
      USE GRTOPH
      USE FTRAFO

      IMPLICIT NONE

      INTEGER :: I,J,K,M,N,IERR
      INTEGER :: MAUF,MAXB,MAXL,MLEVEL,MNAUF,MANF,MSMOOTH
      INTEGER :: NGI,NGJ,LUNIT
      REAL  :: WSAVE(4*MAUF+15)
      REAL  :: BREITE(MAXB)
      REAL  :: Z(0:((MNAUF+3)*(MNAUF+4))/2,MAXB)
      REAL  :: T(MAXL, MAXB, MLEVEL)
      REAL  :: OM(MAXL, MAXB, MLEVEL),ETAD(MAXL, MAXB, MLEVEL)
      REAL  :: U(MAXL, MAXB, MLEVEL), V(MAXL, MAXB, MLEVEL)
      REAL  :: PS(MAXL, MAXB, MLEVEL)
      REAL  :: X1,X2


      REAL, ALLOCATABLE, DIMENSION (:,:) :: P,PP
      REAL, ALLOCATABLE, DIMENSION (:,:) :: XMN,CXM
      REAL, ALLOCATABLE, DIMENSION (:) :: LNPMN,LNPMN2,H
      REAL, ALLOCATABLE, DIMENSION (:) :: GBREITE,WEIGHT,A,B
      REAL, ALLOCATABLE, DIMENSION (:,:) :: TG, UG, VG
      REAL, ALLOCATABLE, DIMENSION (:,:) :: DG, ETAG
      REAL, ALLOCATABLE, DIMENSION (:,:) :: GWSAVE
      REAL, ALLOCATABLE, DIMENSION (:) :: DPSDL, DPSDM
      REAL, ALLOCATABLE, DIMENSION (:) :: PSG,HILF

      INTEGER, ALLOCATABLE, DIMENSION (:) :: MLAT

      call PBOPEN(LUNIT,'fort.17','r',IERR)
      if(ierr.lt.0) stop ' SUBROUTINE PBOPEN: ERROR OPENING fort.17'
       
      call PBGRIB(LUNIT,INBUFF,JPACK*8,LENGHT,IERR)
      if(ierr.lt.-1) stop ' SUBROUTINE PBOPEN: ERROR READING fort.17'

      YOPER = 'D'
      IERR = 1
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)
      IF (IERR.NE.0) STOP 'SORRY: GRIB CODE CONVERSION ERROR'

      IF(ISEC2(1) .NE. 4) stop 'FATAL: first field in fort.17 is
     * not on Gaussian Grid'

      IF(ISEC2(3) .NE. MNAUF+1) THEN
        write(*,*) 'Gaussian grid N',ISEC2(2),' is not compatible'
        write(*,*) 'with spectral resolution',MNAUF 
        STOP
      ENDIF

      NGJ=MNAUF+1

      ALLOCATE (GWSAVE(8*NGJ+15,NGJ/2))
      ALLOCATE (GBREITE(NGJ),WEIGHT(NGJ))
      ALLOCATE (MLAT(NGJ),CXM(4*NGJ,NGJ))
      ALLOCATE (P(0:((MNAUF+3)*(MNAUF+4))/2,NGJ/2))
      ALLOCATE (PP(NGJ/2,0:((MNAUF+3)*(MNAUF+4))/2))
      ALLOCATE (H(0:(MNAUF+2)*(MNAUF+3)/2))
      ALLOCATE (A(MLEVEL+1),B(MLEVEL+1))

      MLAT=ISEC2(23:23+NGJ-1)
      NGI=SUM(MLAT)
!      GMLAT=2*NGJ
!      NGI=2*NGJ*NGJ

      IF(ISEC2(12)/2-1 .ne. MLEVEL) THEN 
        WRITE(*,*) 'FATAL: Number of model levels',
     *ISEC2(12)/2-1,' does not agree with', MLEVEL,' in namelist'
        STOP
      ENDIF
      A=ZSEC2(11:11+MLEVEL)
      B=ZSEC2(11+MLEVEL+1:11+2*MLEVEL+1)

      ALLOCATE (XMN(0:(MNAUF+1)*(MNAUF+2)-1, 3*MLEVEL))
      ALLOCATE (LNPMN(0:(MNAUF+1)*(MNAUF+2)-1))
      ALLOCATE (LNPMN2(0:(MNAUF+1)*(MNAUF+2)-1))
      ALLOCATE (UG(NGI, MLEVEL), VG(NGI, MLEVEL))

      ALLOCATE (DG(NGI,MLEVEL),ETAG(NGI,MLEVEL))

      ALLOCATE (DPSDL(NGI),DPSDM(NGI))

      ALLOCATE (PSG(NGI),HILF(NGI))


C Initialisieren der Felder fuer FFT und Legendretransformation
C	auf das Gauss'sche Gitter und zurueck in den Phasenraum
	X1=-1.D0
	X2=1.D0
	CALL GAULEG(X1,X2,GBREITE,WEIGHT,NGJ)
!	CALL MLATINI(MLAT,NGI)

!$OMP PARALLEL DO PRIVATE(M)
	DO J=1,NGJ/2
		CALL PLGNFA(MNAUF,GBREITE(J),P(:,J))
		DO M=0,(MNAUF+3)*(MNAUF+4)/2
		  PP(J,M)=P(M,J)
	ENDDO
!$OMP CRITICAL
		CALL CFFTI(MLAT(J),GWSAVE(1,J))	
!$OMP END CRITICAL
	ENDDO
!$OMP END PARALLEL DO

        CALL READSPECTRAL('fort.12',LNPMN,MNAUF,1,1,(/152/))
	CALL PHGR213(LNPMN,HILF,GWSAVE,P,MLAT,MNAUF,NGI,NGJ,1)
        HILF=EXP(HILF)
        PSG=HILF
	CALL GRPH213(LNPMN2,PSG,GWSAVE,PP,WEIGHT,MLAT,
     *MNAUF,NGI,NGJ,1)
	CALL PHGR213(LNPMN2,HILF,GWSAVE,P,MLAT,MNAUF,NGI,NGJ,1)

        HILF=PSG-HILF

        HILF=PSG
        CALL READSPECTRAL('fort.11',
     *XMN,MNAUF,3*MLEVEL,3,(/130,131,132/))
C	Transformieren des U-Windes auf das Gaussgitter			
	CALL PHGR213(XMN(0,1*MLEVEL+1),UG,GWSAVE,P,MLAT,MNAUF,NGI,NGJ,MLEVEL)
        CALL PHGCUT(XMN(0,1*MLEVEL+1),U,WSAVE,Z,
     *MNAUF,MNAUF,MAUF,MANF,MAXL,MAXB,MLEVEL)

C	Transformieren des V-Windes auf das Gaussgitter			
	CALL PHGR213(XMN(0,2*MLEVEL+1),VG,GWSAVE,P,MLAT,MNAUF,NGI,NGJ,MLEVEL)
        CALL PHGCUT(XMN(0,2*MLEVEL+1),V,WSAVE,Z,
     *MNAUF,MNAUF,MAUF,MANF,MAXL,MAXB,MLEVEL)

C	Transformieren der Temperatur auf das LAT/LON Gitter
        CALL PHGCUT(XMN(0,0*MLEVEL+1),T,WSAVE,Z,
     *MNAUF,MNAUF,MAUF,MANF,MAXL,MAXB,MLEVEL)

        CALL READSPECTRAL('fort.13',XMN,MNAUF,MLEVEL,1,(/155/))
C	Transformieren der horizontalen Divergenz auf das Gaussgitter			
	CALL PHGR213(XMN,DG,GWSAVE,P,MLAT,MNAUF,NGI,NGJ,MLEVEL)


C	Berechnung des Gradienten des Logarithmus des Bodendrucks 
C       auf dem Gaussgitter	
	CALL PHGRAD(LNPMN,DPSDL,DPSDM,
     *GWSAVE,P,H,MLAT,MNAUF,NGI,NGJ,1)

C	Berechnung der Vertikalgeschwindigkeit auf dem Gaussgitter
      CALL CONTGL(HILF,DPSDL,DPSDM,DG,UG,VG,GBREITE,ETAG,
     *MLAT,A,B,NGI,NGJ,MLEVEL)

 
	CALL GRPH213(XMN,ETAG,GWSAVE,PP,WEIGHT,MLAT,
     *MNAUF,NGI,NGJ,MLEVEL)
        DO K=1,MLEVEL
          IF(MSMOOTH .ne. 0) CALL SPFILTER(XMN(:,K),MNAUF,MSMOOTH)
        ENDDO
        CALL PHGCUT(XMN,ETAD,WSAVE,Z,
     *MNAUF,MNAUF,MAUF,MANF,MAXL,MAXB,MLEVEL)

C	Berechnung von Omega auf dem Gaussgitter
	CALL OMEGA(PSG,DPSDL,DPSDM,DG,UG,VG,GBREITE,ETAG,MLAT,A,B,NGI
     *	 ,NGJ,MLEVEL) 

	CALL GRPH213(XMN,ETAG,GWSAVE,PP,WEIGHT,MLAT,
     *MNAUF,NGI,NGJ,MLEVEL)
        DO K=1,MLEVEL
          IF(MSMOOTH .ne. 0) CALL SPFILTER(XMN(:,K),MNAUF,MSMOOTH)
        ENDDO
        CALL PHGCUT(XMN,OM,WSAVE,Z,
     *MNAUF,MNAUF,MAUF,MANF,MAXL,MAXB,MLEVEL)


        DEALLOCATE(HILF,PSG,DPSDL,DPSDM,ETAG,DG,VG,UG,LNPMN,XMN)
        DEALLOCATE(PP,P,MLAT,GBREITE,WEIGHT,GWSAVE)


      RETURN
      END SUBROUTINE ETAGAUSS

      END MODULE GAUSS
