      MODULE GRTOPH

      USE PHTOGR

      CONTAINS

      SUBROUTINE GRPH214(CXMN,CXM,FELD,WSAVE,Z,W,MLAT,
     *MNAUF,MAXL,MAXB,MLEVEL)

C     DIE ROUTINE F]HRT EINE TRANSFORMATION EINER
C     FELDVARIABLEN VOM PHASENRAUM IN  DEN PHYSIKALISCHEN
C     RAUM AUF KUGELKOORDINATEN DURCH
C
C     CXMN   = SPEKTRALKOEFFIZIENTEN IN DER REIHENFOLGE
C              CX00,CX01,CX11,CX02,....CXMNAUFMNAUF
C			CXM		 = FOURIERKOEFFIZIENTEN - nur ein Hilfsfeld
C     FELD   = FELD DER METEOROLOGISCHEN VARIABLEN
C			WSAVE  = Working Array fuer Fouriertransformation
C     Z 	 = LEGENDREFUNKTIONSWERTE
C
C     MNAUF    ANZAHL DER FOURIERKOEFFIZIENTEN
C     MAXL     ANZAHL DER FUER DAS GITTER BENUTZTEN LAENGEN
C     MAXB     ANZAHL DER FUER DAS GITTER BENOETIGTEN BREITEN
C     MLEVEL   ANZAHL DER LEVELS, DIE TRANSFORMIERT WERDEN
C

      USE PHTOGR
      IMPLICIT REAL (A-H,O-Z)

C    FELD DER FOURIERKOEFFIZIENTEN
      DIMENSION CXMS(2*MAXAUF)
      DIMENSION CXMA(2*MAXAUF)
      DIMENSION CXM(4*MAXB,MAXB)

C			Anzahl der Gitterpunkte pro Breitenkreis des reduzierten 
C			Gauss'schen Gitters
			INTEGER MLAT(MAXB)
			
C    FELD DER LEGENDREPOLYNOME FUER EINE BREITE
      REAL*8 Z(0:((MNAUF+3)*(MNAUF+4))/2,MAXB/2)

      DIMENSION CXMN(0:(MNAUF+2)*(MNAUF+3)-1,MLEVEL)
      REAL FELD(MAXL,MLEVEL)
      DIMENSION WSAVE(8*MAXB+15,MAXB/2)
      REAL*8 W(MAXB)

      DO 6 L=1,MLEVEL
      	IND=0
	  		DO 5 J=1,MAXB/2
	    		CALL FOUFTR(CXMS,FELD(IND+1,L),WSAVE(1,J),MNAUF,MLAT(J),1)
	    		CALL FOUFTR(CXMA,FELD(MAXL-IND-MLAT(J)+1,L),
     *WSAVE(1,J),MNAUF,MLAT(J),1)
	    		DO 4 I=1,2*(MNAUF+1)
	    			CXM(I,J)=CXMS(I)+CXMA(I)
	    			CXM(I,MAXB+1-J)=CXMS(I)-CXMA(I)
4					CONTINUE
					IND=IND+MLAT(J)
    5 	CONTINUE
        CALL LGTR214(CXMN(0,L),CXM,Z,W,MLAT,MNAUF,MAXB)
    6 CONTINUE

      RETURN
      END SUBROUTINE GRPH214
C
        SUBROUTINE LGTR214(CXMN,CXM,Z,W,MLAT,MNAUF,MAXB)
        IMPLICIT REAL (A-H,O-Z)
        INTEGER MLAT(MAXB)
        DIMENSION CXM(0:4*MAXB-1,MAXB)
        DIMENSION CXMN(0:(MNAUF+2)*(MNAUF+3)-1)
        REAL*8 Z(0:((MNAUF+3)*(MNAUF+4))/2,MAXB/2)
        REAL*8 W(MAXB),CR,CI
C
C     DIESE ROUTINE BERECHNET DIE KFFKs CXMN
C
      DO 1 I=0,MNAUF
        INDEX=((I+1)*I)/2
        DO 2 J=I,MNAUF+1
          INDEX=INDEX+J
          CR=0
          CI=0
          DO 3 K=1,MAXB/2
        		IF(2*I+1.LT.MLAT(K)) THEN
            	IF(MOD(I+J,2).EQ.0) THEN
        	CR=CR+CXM(2*I,K)*W(K)*Z(INDEX,K)
        	CI=CI+CXM(2*I+1,K)*W(K)*Z(INDEX,K)
            	ELSE
        	CR=CR+CXM(2*I,MAXB+1-K)*W(K)*Z(INDEX,K)
        	CI=CI+CXM(2*I+1,MAXB+1-K)*W(K)*Z(INDEX,K)
            	ENDIF
            ENDIF
    3     	CONTINUE
          CXMN(2*INDEX)=CR
          CXMN(2*INDEX+1)=CI
    2   CONTINUE
    1 CONTINUE
        RETURN
        END SUBROUTINE LGTR214
C
      SUBROUTINE GRPH213(CXMN,FELD,WSAVE,Z,W,MLAT,
     *MNAUF,MAXL,MAXB,MLEVEL)

C     DIE ROUTINE F]HRT EINE TRANSFORMATION EINER
C     FELDVARIABLEN VOM PHASENRAUM IN  DEN PHYSIKALISCHEN
C     RAUM AUF KUGELKOORDINATEN DURCH
C
C     CXMN   = SPEKTRALKOEFFIZIENTEN IN DER REIHENFOLGE
C              CX00,CX01,CX11,CX02,....CXMNAUFMNAUF
C			CXM		 = FOURIERKOEFFIZIENTEN - nur ein Hilfsfeld
C     FELD   = FELD DER METEOROLOGISCHEN VARIABLEN
C			WSAVE  = Working Array fuer Fouriertransformation
C     Z 	 = LEGENDREFUNKTIONSWERTE
C
C     MNAUF    ANZAHL DER FOURIERKOEFFIZIENTEN
C     MAXL     ANZAHL DER FUER DAS GITTER BENUTZTEN LAENGEN
C     MAXB     ANZAHL DER FUER DAS GITTER BENOETIGTEN BREITEN
C     MLEVEL   ANZAHL DER LEVELS, DIE TRANSFORMIERT WERDEN
C
      IMPLICIT REAL (A-H,O-Z)


C			Anzahl der Gitterpunkte pro Breitenkreis des reduzierten 
C			Gauss'schen Gitters
			INTEGER MLAT(MAXB),ISIZE
			
C    FELD DER LEGENDREPOLYNOME FUER EINE BREITE
      REAL*8 Z(MAXB/2,0:((MNAUF+3)*(MNAUF+4))/2)
      
C      LOGICAL*1 USED(((216*217)/2+1)*160)

      DIMENSION CXMN(0:(MNAUF+1)*(MNAUF+2)-1,MLEVEL)
      REAL FELD(MAXL,MLEVEL)
      DIMENSION WSAVE(8*MAXB+15,MAXB/2)
      REAL*8 W(MAXB) 
      DIMENSION IND(MAXB)
			
			
      	IND(1)=0
      DO 6 J=2,MAXB/2
	 IND(j)=IND(J-1)+MLAT(J-1)
 6    CONTINUE
!$OMP PARALLEL DO SCHEDULE(DYNAMIC)
      DO 16 L=1,MLEVEL
        CALL GRPHSUB(L,IND,CXMN,FELD,WSAVE,Z,W,MLAT,
     *MNAUF,MAXL,MAXB,MLEVEL)
16    CONTINUE
!$omp end parallel do


      RETURN
      END SUBROUTINE GRPH213
C
      SUBROUTINE GRPHSUB(L,IND,CXMN,FELD,WSAVE,Z,W,MLAT,
     *MNAUF,MAXL,MAXB,MLEVEL)

C     DIE ROUTINE F]HRT EINE TRANSFORMATION EINER
C     FELDVARIABLEN VOM PHASENRAUM IN  DEN PHYSIKALISCHEN
C     RAUM AUF KUGELKOORDINATEN DURCH
C
C     CXMN   = SPEKTRALKOEFFIZIENTEN IN DER REIHENFOLGE
C              CX00,CX01,CX11,CX02,....CXMNAUFMNAUF
C			CXM		 = FOURIERKOEFFIZIENTEN - nur ein Hilfsfeld
C     FELD   = FELD DER METEOROLOGISCHEN VARIABLEN
C			WSAVE  = Working Array fuer Fouriertransformation
C     Z 	 = LEGENDREFUNKTIONSWERTE
C
C     MNAUF    ANZAHL DER FOURIERKOEFFIZIENTEN
C     MAXL     ANZAHL DER FUER DAS GITTER BENUTZTEN LAENGEN
C     MAXB     ANZAHL DER FUER DAS GITTER BENOETIGTEN BREITEN
C     MLEVEL   ANZAHL DER LEVELS, DIE TRANSFORMIERT WERDEN
C
      IMPLICIT REAL (A-H,O-Z)

C    FELD DER FOURIERKOEFFIZIENTEN
      REAL CXMS(4*(MNAUF+1))
      REAL CXMA(4*(MNAUF+1))
      REAL,ALLOCATABLE :: CXM(:,:)

C			Anzahl der Gitterpunkte pro Breitenkreis des reduzierten 
C			Gauss'schen Gitters
			INTEGER MLAT(MAXB),ISIZE
			
C    FELD DER LEGENDREPOLYNOME FUER EINE BREITE
      REAL Z(MAXB/2,0:((MNAUF+3)*(MNAUF+4))/2)
      
C      LOGICAL*1 USED(((216*217)/2+1)*160)

      REAL CXMN(0:(MNAUF+1)*(MNAUF+2)-1,MLEVEL)
      REAL FELD(MAXL,MLEVEL)
      REAL WSAVE(8*MAXB+15,MAXB/2)
      REAL W(MAXB)
      INTEGER IND(MAXB)
			
      ALLOCATE(CXM( 4*MAXB,MAXB))
	  		DO 5 J=1,MAXB/2
	    		CALL FOUFTR(CXMS,FELD(IND(J)+1,L),WSAVE(1,J),MNAUF,MLAT(J),1)
	    		CALL FOUFTR(CXMA,FELD(MAXL-IND(J)-MLAT(J)+1,L),
     *WSAVE(1,J),MNAUF,MLAT(J),1)
	    		DO 4 I=1,2*(MNAUF+1)
	    			CXM(I,J)=CXMS(I)+CXMA(I)
	    			CXM(I,MAXB+1-J)=CXMS(I)-CXMA(I)
4					CONTINUE
    5 	CONTINUE
        CALL LGTR213(CXMN(0,L),CXM,Z,W,MLAT,MNAUF,MAXB)

      DEALLOCATE(CXM)

      RETURN
      END SUBROUTINE GRPHSUB
C
        SUBROUTINE LGTR213(CXMN,CXM,Z,W,MLAT,MNAUF,MAXB)
        IMPLICIT REAL (A-H,O-Z)
        INTEGER MLAT(MAXB)
        DIMENSION CXM(0:4*MAXB-1,MAXB)
        DIMENSION CXMN(0:2*(((MNAUF+1)*MNAUF)/2+MNAUF)+1)
        REAL*8 Z(MAXB/2,0:((MNAUF+3)*(MNAUF+4))/2)
        REAL*8 W(MAXB),CR,CI,HILF
        LOGICAL EVEN
C
C     DIESE ROUTINE BERECHNET DIE KFFKs CXMN
C
			LL=0
			LLP=0
      DO 1 I=0,MNAUF
        KM=0
    9   KM=KM+1
        IF(MLAT(KM).LE.2*I) THEN
           GOTO 9
        ENDIF
        DO 2 J=I,MNAUF
          CR=0
          CI=0
          EVEN=MOD(I+J,2).EQ.0
          IF(EVEN) THEN
            DO 3 K=KM,MAXB/2
        			  HILF=W(K)*Z(K,LLP)
        	      CR=CR+CXM(2*I,K)*HILF
        	      CI=CI+CXM(2*I+1,K)*HILF
    3     	CONTINUE
          ELSE
            DO 4 K=KM,MAXB/2
        			  HILF=W(K)*Z(K,LLP)
        	      CR=CR+CXM(2*I,MAXB+1-K)*HILF
        	      CI=CI+CXM(2*I+1,MAXB+1-K)*HILF
    4     	CONTINUE
          ENDIF
    5     CXMN(2*LL)=CR
          CXMN(2*LL+1)=CI
          LL=LL+1
          LLP=LLP+1
    2   CONTINUE
        LLP=LLP+2
    1 CONTINUE
        RETURN
        END SUBROUTINE LGTR213
C
	subroutine transp(farr,used,ni,nj)
	implicit none
	integer i,j,indexa,indexn,indexorig,ni,nj,l
	real*8 farr(ni*nj),swapn,hilf
	logical*1 used(ni*nj)
	
	l=1
	indexorig=2
1	if(l.eq.ni*nj-3) return

3	continue
	if(used(indexorig)) then
	  indexorig=indexorig+1
	  goto 3
	endif
	
	indexa=indexorig
	swapn=farr(indexa)
2	continue	
	j=(indexa-1)/ni+1
	i=indexa-(j-1)*ni	
	indexn=(i-1)*nj+j
	used(indexa)=.true.
	l=l+1
	if(indexn.eq.indexorig) then
	  farr(indexn)=hilf
	  goto 1
	endif
	swapn=farr(indexn)
	farr(indexn)=hilf
	indexa=indexn
	goto 2
	  
	end SUBROUTINE transp

      SUBROUTINE GRPHNC(CXMN,CXM,FELD,WSAVE,Z,W,MLAT,
     *MNAUF,MAXL,MAXB,MLEVEL)

C     DIE ROUTINE F]HRT EINE TRANSFORMATION EINER
C     FELDVARIABLEN VOM PHASENRAUM IN  DEN PHYSIKALISCHEN
C     RAUM AUF KUGELKOORDINATEN DURCH. 
C			Anzahl der Gitterpunkte pro Breitenkreis: 2(MAXB+2) d.h.
C	    NCEP-Implementierung
C
C     CXMN   = SPEKTRALKOEFFIZIENTEN IN DER REIHENFOLGE
C              CX00,CX01,CX11,CX02,....CXMNAUFMNAUF
C			CXM		 = FOURIERKOEFFIZIENTEN - nur ein Hilfsfeld
C     FELD   = FELD DER METEOROLOGISCHEN VARIABLEN
C			WSAVE  = Working Array fuer Fouriertransformation
C     Z 	 = LEGENDREFUNKTIONSWERTE
C
C     MNAUF    ANZAHL DER FOURIERKOEFFIZIENTEN
C     MAXL     ANZAHL DER FUER DAS GITTER BENUTZTEN LAENGEN
C     MAXB     ANZAHL DER FUER DAS GITTER BENOETIGTEN BREITEN
C     MLEVEL   ANZAHL DER LEVELS, DIE TRANSFORMIERT WERDEN
C
      IMPLICIT REAL (A-H,O-Z)

C    FELD DER FOURIERKOEFFIZIENTEN
      DIMENSION CXMS(2*MAXAUF)
      DIMENSION CXMA(2*MAXAUF)
      DIMENSION CXM(4*(MAXB+2),MAXB)

C			Anzahl der Gitterpunkte pro Breitenkreis des reduzierten 
C			Gauss'schen Gitters
			INTEGER MLAT(MAXB)
			
C    FELD DER LEGENDREPOLYNOME FUER EINE BREITE
      REAL*8 Z(0:((MNAUF+3)*(MNAUF+4))/2,MAXB/2)

      DIMENSION CXMN(0:(MNAUF+1)*(MNAUF+2)-1,MLEVEL)
      REAL FELD(MAXL,MLEVEL)
      DIMENSION WSAVE(8*(MAXB+2)+15,MAXB/2)
      REAL*8 W(MAXB)

      DO 6 L=1,MLEVEL
      	IND=0
	  		DO 5 J=1,MAXB/2
	    		CALL FOUFTR(CXMS,FELD(IND+1,L),WSAVE(1,J),MNAUF,MLAT(J),1)
	    		CALL FOUFTR(CXMA,FELD(MAXL-IND-MLAT(J)+1,L),
     *WSAVE(1,J),MNAUF,MLAT(J),1)
	    		DO 4 I=1,2*(MNAUF+1)
	    			CXM(I,J)=CXMS(I)+CXMA(I)
	    			CXM(I,MAXB+1-J)=CXMS(I)-CXMA(I)
4					CONTINUE
					IND=IND+MLAT(J)
    5 	CONTINUE
        CALL LGTRNC(CXMN(0,L),CXM,Z,W,MLAT,MNAUF,MAXB)
    6 CONTINUE

      RETURN
      END SUBROUTINE GRPHNC
C
        SUBROUTINE LGTRNC(CXMN,CXM,Z,W,MLAT,MNAUF,MAXB)
        IMPLICIT REAL (A-H,O-Z)
        INTEGER MLAT(MAXB)
        DIMENSION CXM(0:4*(MAXB+2)-1,MAXB)
        DIMENSION CXMN(0:2*(((MNAUF+1)*MNAUF)/2+MNAUF)+1)
        REAL*8 Z(0:((MNAUF+3)*(MNAUF+4))/2,MAXB/2)
        REAL*8 W(MAXB),CR,CI,HILF
        LOGICAL EVEN
C
C     DIESE ROUTINE BERECHNET DIE KFFKs CXMN
C
      DO 1 I=0,MNAUF
        INDEX=((I+1)*I)/2
        DO 2 J=I,MNAUF
          INDEX=INDEX+J
          CR=0
          CI=0
          EVEN=MOD(I+J,2).EQ.0
          DO 3 K=1,MAXB/2
        		IF(2*I+1.LT.MLAT(K)) THEN
        			HILF=W(K)*Z(INDEX,K)
            	IF(EVEN) THEN
        	CR=CR+CXM(2*I,K)*HILF
        	CI=CI+CXM(2*I+1,K)*HILF
            	ELSE
        	CR=CR+CXM(2*I,MAXB+1-K)*HILF
        	CI=CI+CXM(2*I+1,MAXB+1-K)*HILF
            	ENDIF
            ENDIF
    3     	CONTINUE
          CXMN(2*INDEX)=CR
          CXMN(2*INDEX+1)=CI
    2   CONTINUE
    1 CONTINUE
        RETURN
        END SUBROUTINE LGTRNC
C
      SUBROUTINE GRTOPHUR(CXMN,CXM,FELD,WSAVE,Z,W,
     *MNAUF,MAXL,MAXB,MLEVEL)

C     DIE ROUTINE F]HRT EINE TRANSFORMATION EINER
C     FELDVARIABLEN VOM PHASENRAUM IN  DEN PHYSIKALISCHEN
C     RAUM AUF KUGELKOORDINATEN DURCH
C
C     CXMN   = SPEKTRALKOEFFIZIENTEN IN DER REIHENFOLGE
C              CX00,CX01,CX11,CX02,....CXMNAUFMNAUF
C			CXM		 = FOURIERKOEFFIZIENTEN - nur ein Hilfsfeld
C     FELD   = FELD DER METEOROLOGISCHEN VARIABLEN
C	WSAVE  = Working Array fuer Fouriertransformation
C     Z 	 = LEGENDREFUNKTIONSWERTE
C
C     MNAUF    ANZAHL DER FOURIERKOEFFIZIENTEN
C     MAXL     ANZAHL DER FUER DAS GITTER BENUTZTEN LAENGEN
C     MAXB     ANZAHL DER FUER DAS GITTER BENOETIGTEN BREITEN
C     MLEVEL   ANZAHL DER LEVELS, DIE TRANSFORMIERT WERDEN
C
      IMPLICIT REAL (A-H,O-Z)

C    FELD DER FOURIERKOEFFIZIENTEN
      DIMENSION CXMS(2*MAXAUF)
      DIMENSION CXMA(2*MAXAUF)
      DIMENSION CXM(2*MAXL,MAXB)

C    FELD DER LEGENDREPOLYNOME FUER EINE BREITE
      REAL*8 Z(0:((MNAUF+3)*(MNAUF+4))/2,(MAXB+1)/2)

      DIMENSION CXMN(0:(MNAUF+1)*(MNAUF+2)-1,MLEVEL)
      REAL FELD(MAXL,MAXB,MLEVEL)
      DIMENSION WSAVE(4*MAXL+15)
      REAL*8 W(MAXB)

C
      IF(MAXL.LE.MNAUF) THEN
        WRITE(*,*) 'LAENGENAUFLOESUNG ZU GROB'
        STOP
      ENDIF

      DO 6 L=1,MLEVEL
*            WRITE(*,*) L
	  DO 5 J=1,MAXB/2
	    CALL FOUFTR(CXMS,FELD(1,J,L),WSAVE,MNAUF,MAXL,1)
	    CALL FOUFTR(CXMA,FELD(1,MAXB+1-J,L),WSAVE,MNAUF,MAXL,1)
	    DO 4 I=1,2*(MNAUF+1)
	    	CXM(I,J)=CXMS(I)+CXMA(I)
	    	CXM(I,MAXB+1-J)=CXMS(I)-CXMA(I)
4			CONTINUE
    5   CONTINUE
        CALL LEGFTR(CXMN(0,L),CXM,Z,W,MNAUF,MAXL,MAXB)
    6 CONTINUE

      RETURN
      END SUBROUTINE GRTOPHUR
C
        SUBROUTINE LEGFTR(CXMN,CXM,Z,W,MNAUF,MAXL,MAXB)
        IMPLICIT REAL (A-H,O-Z)
        DIMENSION CXM(0:2*MAXL-1,MAXB)
        DIMENSION CXMN(0:2*(((MNAUF+1)*MNAUF)/2+MNAUF)+1)
        REAL*8 Z(0:((MNAUF+3)*(MNAUF+4))/2,(MAXB+1)/2)
        REAL*8 W(MAXB),CR,CI
C
C     DIESE ROUTINE BERECHNET DIE KFFKs CXMN
C
      DO 1 I=0,MNAUF
        INDEX=((I+1)*I)/2
        DO 2 J=I,MNAUF
          INDEX=INDEX+J
          CR=0
          CI=0
          DO 3 K=1,MAXB/2
            IF(MOD(I+J,2).EQ.0) THEN
        CR=CR+CXM(2*I,K)*W(K)*Z(INDEX,K)
        CI=CI+CXM(2*I+1,K)*W(K)*Z(INDEX,K)
            ELSE
        CR=CR+CXM(2*I,MAXB+1-K)*W(K)*Z(INDEX,K)
        CI=CI+CXM(2*I+1,MAXB+1-K)*W(K)*Z(INDEX,K)
            ENDIF
    3     CONTINUE
          CXMN(2*INDEX)=CR
          CXMN(2*INDEX+1)=CI
    2   CONTINUE
    1 CONTINUE
        RETURN
        END SUBROUTINE LEGFTR
C
      SUBROUTINE FOUFTR(CXM,FELD,WSAVE,MNAUF,MAXL,ISIGN)
C     BERECHNET DIE FOURIERSUMME MIT EINEM FFT-ALGORITHMUS
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION CXM(0:2*MAXL-1)
      DIMENSION FELD(MAXL)
      DIMENSION WSAVE(*)


C NORMIERUNG...
      DO 11 I=0,MAXL-1
        CXM(2*I)=FELD(I+1)/MAXL/2
        CXM(2*I+1)=0.0
   11 CONTINUE
!$OMP CRITICAL
      CALL CFFTF(MAXL,CXM,WSAVE)
!$OMP END CRITICAL
      RETURN
      END SUBROUTINE FOUFTR
C     
C	Initialisierung des Feldes MLAT
C	MLAT enthaeld die Anzahl der Gitterpunkte pro Breitenkreis auf dem
C	reduzierten Gauss'schen Gitter des ECMWF
C	MBREI ist die Anzahl der Gauss'schen Breiten (normalerweise 320)
C	Ist MBREI kleiner, wird ein regelmaessiges Gaussgitter
C	angenommen

	SUBROUTINE MLATINI(MLAT,NGI)
	
	INTEGER MLAT(*)

C NCEP-Gaussgitter	
	IF(NGI.EQ.18048) THEN
			DO 120 I=1,94
				MLAT(I)=192
120		CONTINUE
	ENDIF
	
C	ECMWF-Gaussgitter
	IF(NGI.EQ.51200) THEN
			DO 100 I=1,160
				MLAT(I)=320
100		CONTINUE
	ENDIF
	IF(NGI.EQ.134028) THEN
      MLAT(1)=12
      MLAT(2)=16
      MLAT(3)=20
      MLAT(4)=24
      MLAT(5)=30
      MLAT(6)=40
      MLAT(7)=45
      MLAT(8)=50
      MLAT(9)=60
      MLAT(10)=64
      MLAT(11)=72
      MLAT(12)=75
      MLAT(13)=80
      MLAT(14)=90
      MLAT(15)=96
      MLAT(16)=100
      MLAT(17)=108
      MLAT(18)=120
      MLAT(19)=120
      MLAT(20)=128
      MLAT(21)=135
      MLAT(22)=144
      MLAT(23)=144
      MLAT(24)=150
      MLAT(25)=160
      MLAT(26)=160
      MLAT(27)=180
      MLAT(28)=180
      MLAT(29)=180
      MLAT(30)=192
      MLAT(31)=192
      MLAT(32)=200
      MLAT(33)=216
      MLAT(34)=216
      MLAT(35)=216
      MLAT(36)=225
      MLAT(37)=240
      MLAT(38)=240
      MLAT(39)=240
      MLAT(40)=256
      MLAT(41)=256
      MLAT(42)=256
      DO 1 I=43,47
1        MLAT(I)=288
      DO 2 I=48,50
2       MLAT(I)=300
      DO 3 I=51,53
3       MLAT(I)=320
      MLAT(54)=324
      DO 4 I=55,61
4       MLAT(I)=360
      DO 5 I=62,64
5       MLAT(I)=375
      MLAT(65)=384
      DO 6 I=66,69
6       MLAT(I)=400
      MLAT(70)=405
      DO 7 I=71,75
7       MLAT(I)=432
      DO 8 I=76,79
8       MLAT(I)=450
      DO 9 I=80,86
9       MLAT(I)=480
      DO 10 I=87,91
10      MLAT(I)=500
      DO 11 I=92,94
11      MLAT(I)=512
      DO 12 I=95,102
12      MLAT(I)=540
      DO 13 I=103,114
13      MLAT(I)=576
      DO 14 I=115,124
14      MLAT(I)=600
      DO 15 I=125,160
15      MLAT(I)=640
      DO 16 I=1,320/2
16	  MLAT(320/2+I)=MLAT(320/2+1-I)

	ENDIF
	
	IF(NGI.EQ.138346) THEN
      MLAT(1)=18
      MLAT(2)=25
      MLAT(3)=36
      MLAT(4)=40
      MLAT(5)=45
      MLAT(6)=50
      MLAT(7)=60
      MLAT(8)=64
      MLAT(9)=72
      MLAT(10)=72
      MLAT(11)=80
      MLAT(12)=90
      MLAT(13)=90
      MLAT(14)=96
      MLAT(15)=108
      MLAT(16)=120
      MLAT(17)=120
      MLAT(18)=125
      MLAT(19)=128
      MLAT(20)=135
      MLAT(21)=144
      MLAT(22)=150
      MLAT(23)=160
      MLAT(24)=160
      MLAT(25)=180
      MLAT(26)=180
      MLAT(27)=180
      MLAT(28)=192
      MLAT(29)=192
      MLAT(30)=200
      MLAT(31)=216
      MLAT(32)=216
      MLAT(33)=225
      MLAT(34)=225
      MLAT(35)=240
      MLAT(36)=240
      MLAT(37)=243
      MLAT(38)=250
      MLAT(39)=256
      MLAT(40)=270
      MLAT(41)=270
      DO 101 I=42,44
101        MLAT(I)=288
      DO 102 I=45,46
102       MLAT(I)=300
      DO 103 I=47,50
103       MLAT(I)=320
      MLAT(51)=324
      DO 104 I=52,57
104       MLAT(I)=360
      DO 105 I=58,60
105       MLAT(I)=375
      DO 1055 I=61,62
1055       MLAT(I)=384
      DO 106 I=63,65
106       MLAT(I)=400
      MLAT(66)=405
      DO 107 I=67,71
107       MLAT(I)=432
      DO 108 I=72,75
108       MLAT(I)=450
      DO 109 I=76,82
109       MLAT(I)=480
      DO 110 I=83,87
110      MLAT(I)=500
      DO 111 I=88,89
111      MLAT(I)=512
      DO 112 I=90,97
112      MLAT(I)=540
      DO 113 I=98,107
113      MLAT(I)=576
      DO 114 I=108,116
114      MLAT(I)=600
      DO 115 I=117,160
115      MLAT(I)=640
      DO 116 I=1,320/2
116	  MLAT(320/2+I)=MLAT(320/2+1-I)

	ENDIF
	
	IF(NGI.EQ.35718) THEN
      MLAT(1)=18
      MLAT(2)=25
      MLAT(3)=36
      MLAT(4)=40
      MLAT(5)=45
      MLAT(6)=54
      MLAT(7)=60
      MLAT(8)=64
      MLAT(9)=72
      MLAT(10)=72
      MLAT(11)=80
      MLAT(12)=90
      MLAT(13)=96
      MLAT(14)=100
      MLAT(15)=108
      MLAT(16)=120
      MLAT(17)=120
      MLAT(18)=128
      MLAT(19)=135
      MLAT(20)=144
      MLAT(21)=144
      MLAT(22)=150
      MLAT(23)=160
      MLAT(24)=160
      MLAT(25)=180
      MLAT(26)=180
      MLAT(27)=180
      MLAT(28)=192
      MLAT(29)=192
      MLAT(30)=200
      MLAT(31)=200
      MLAT(32)=216
      MLAT(33)=216
      MLAT(34)=216
      MLAT(35)=225
      MLAT(36)=225
      MLAT(37)=240
      MLAT(38)=240
      MLAT(39)=240
      DO 201 I=40,43
201        MLAT(I)=256
      DO 202 I=44,52
202       MLAT(I)=288
      DO 203 I=53,56
203       MLAT(I)=300
      DO 204 I=57,80
204       MLAT(I)=320
      DO 206 I=1,160/2
206	  MLAT(160/2+I)=MLAT(160/2+1-I)

	ENDIF
	RETURN
	END SUBROUTINE MLATINI

      END MODULE GRTOPH
