      MODULE RWGRIB

      INTEGER JPACK,JPUNP,IFIELD,IWORD
      INTEGER INDE,LENGHT,levtotal,LEV

      INTEGER ISEC0(2)
      INTEGER ISEC1(56)

      INTEGER, ALLOCATABLE, DIMENSION (:) :: ISEC2

      INTEGER ISEC3(2)
      INTEGER ISEC4(6400)
      
      REAL*8, ALLOCATABLE, DIMENSION (:) ::  ZSEC2

      REAL*8 ZSEC3(2)

      INTEGER, ALLOCATABLE, DIMENSION (:) :: INBUFF

      REAL*8, ALLOCATABLE, DIMENSION (:) :: ZSEC4,ZSEC5
 
      CHARACTER*1 YOPER

      CONTAINS

      SUBROUTINE GRIBINI(MAXL,MAXB,MAUF,MNAUF,MLEVEL)

      IMPLICIT NONE

      INTEGER MAXL,MAXB,MAUF,MNAUF,MLEVEL

*******************************************************************
*     GRIB STUFF *
*******************************************************************

      JPUNP=(MNAUF+1)*(MNAUF+2)*2+3000 ! approx. grid size of Gaussian grid
      IF(MAXL*MAXB .GT. JPUNP) JPUNP=MAXL*MAXB+3000
      JPACK=JPUNP

      ALLOCATE (ISEC2(22+MAXL+MAXB+2000))

      ALLOCATE (ZSEC2(60+2*MLEVEL+1000))

      ALLOCATE (INBUFF(JPACK))

      ALLOCATE (ZSEC4(JPUNP),ZSEC5(JPUNP))

      END SUBROUTINE GRIBINI

      SUBROUTINE READLATLON(FILENAME,FELD,MAXL,MAXB,MLEVEL,
     *MSTRIDE,MPAR)

      IMPLICIT NONE

      INTEGER IFIELD,MLEVEL,MNAUF,I,J,K,L,MSTRIDE,IOFFSET,IREST
      INTEGER MPAR(MSTRIDE),MAXL,MAXB,IERR
      INTEGER*4 LUNIT
      CHARACTER*80 FILENAME
      REAL    FELD(MAXL,MAXB,MLEVEL)

      call PBOPEN(LUNIT,trim(FILENAME),'r',IERR)
      IF(IERR.lt.0) THEN
         WRITE(*,*)  ' SUBROUTINE PBOPEN: ERROR OPENING ',FILENAME
         STOP
      ENDIF

      ifield=0
      DO WHILE(.TRUE.)

      ifield=ifield+1
*
*     Get next fields
*
      call PBGRIB(LUNIT,INBUFF,JPACK*8,LENGHT,IERR)
C                                                                               
      WRITE(*,*) ifield,LENGHT
      if(ierr.eq.-1 .or. LENGHT .le. 1) THEN
          if(LENGHT .le. 1) ifield=ifield-1
          EXIT   ! EOF DETECTED
      endif
      if(ierr.lt.-1) EXIT  ! ERROR DETECTED

      YOPER = 'D'
      IERR = 1
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)

      IF (IERR.NE.0) STOP 'SORRY: GRIB CODE CONVERSION ERROR'

      IF(ISEC2(2).ne. MAXL.or.ISEC2(3).ne.MAXB) then
         write(*,*) 'PROGRAMM PRECONVERT - ERROR'
         write(*,*) 'FILE ',FILENAME
         write(*,*) 'LAT/LON GRID DETECTED:        ',ISEC2(2),ISEC2(3)
         write(*,*) 'LAT/LON GRID EXPECTED:        ',MAXL,MAXB
         write(*,*) 'PLEASE CHANGE PARAMETER STATEMENT'
         stop
      endif

      IF(ISEC2(12) .ne. 0) then 
        IOFFSET=mod(ifield-1,MSTRIDE)*(ISEC2(12)/2-1)
        IREST=mod(ifield-1,MSTRIDE)
      else
        ioffset=0
        irest=ifield-1
      endif

      IF (ISEC1(6) .ne. MPAR(IREST+1)) THEN
        WRITE(*,*) ifield,' READ PARAMETER',ISEC1(6),
     *'EXPECTED',MPAR(IREST+1)
        STOP
      ENDIF

!      WRITE(*,*) MLEVEL,MSTRIDE,IOFFSET+(ifield-1)/MSTRIDE+1
      FELD(:,:,IOFFSET+(ifield-1)/MSTRIDE+1)=
     *RESHAPE(ZSEC4(1:MAXL*MAXB),(/MAXL,MAXB/))

      ENDDO

      IF(IERR .LT. -1) THEN
        WRITE(*,*) 'Error ',ierr,' occured while reading ',FILENAME 
        STOP
      ENDIF

      CALL PBCLOSE(LUNIT,IERR)

      IF(IFIELD.GT.MLEVEL) THEN
         write(*,*) 'PROGRAMM PRECONVERT - ERROR'
         write(*,*) 'NUMBER OF VERTICAL LEVELS EXPECTED: ',mlevel
         write(*,*) 'TRIED TO READ MORE LEVELS ...'
         stop
      endif

      END SUBROUTINE READLATLON

      SUBROUTINE WRITELATLON(iunit,FELD,MAXL,MAXB,MLEVEL,
     *LEVMIN,LEVMAX,MSTRIDE,MPAR)

      IMPLICIT NONE

      INTEGER IFIELD,MLEVEL,MNAUF,I,J,K,L,MSTRIDE,IERR,JOUT
      INTEGER MPAR(MSTRIDE),MAXL,MAXB,IWRITTEN,LEVMIN,LEVMAX
      INTEGER*4 IUNIT
      REAL    FELD(MAXL,MAXB,MLEVEL)

      ISEC1(38)=1  ! override ERA Interim class
      ISEC1(37)=1  ! override VarEPS
      ISEC1(24)=0  ! override VarEPS
      ISEC4(2)=16  ! 16bit encoding

      DO k=LEVMIN,LEVMAX
        ISEC1(8)=k
        DO j=1,MSTRIDE
        ISEC1(6)=MPAR(j)
         zsec4(1:maxl*maxb)=RESHAPE(FELD(:,:,k),(/maxl*maxb/))
*
         YOPER='C'
         CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     &                ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)
         jout=ISEC0(1)
         call PBWRITE(iunit,INBUFF,jout,iwritten,ierr)
         if(ierr .ne. 0) stop 'GRIB WRITE in WRITELATLON failed'
        ENDDO
      ENDDO

      END SUBROUTINE WRITELATLON

      SUBROUTINE READSPECTRAL(FILENAME,CXMN,MNAUF,MLEVEL,
     *MAXLEV,MSTRIDE,MPAR,A,B)

      IMPLICIT NONE

      INTEGER IFIELD,MLEVEL,MNAUF,I,J,K,L,MSTRIDE,IOFFSET,ML,IREST
      CHARACTER*80 FILENAME
      INTEGER MPAR(MSTRIDE),IERR,MAXLEV
      INTEGER*4 LUNIT
      REAL CXMN(0:(MNAUF+1)*(MNAUF+2)-1,MLEVEL)
      REAL :: A(MAXLEV+1),B(MAXLEV+1)

      call PBOPEN(LUNIT,trim(FILENAME),'r',IERR)
      IF(IERR.lt.0) THEN
         WRITE(*,*)  ' SUBROUTINE PBOPEN: ERROR OPENING ',FILENAME
         STOP
      ENDIF

      ifield=0
      DO WHILE(.TRUE.)

      ifield=ifield+1
*
*     Get next fields
*
      call PBGRIB(LUNIT,INBUFF,JPACK*8,LENGHT,IERR)
C                                                                               
      WRITE(*,*) ifield,LENGHT
      if(ierr.eq.-1 .or. LENGHT .le. 1) THEN
          if(LENGHT .le. 1) ifield=ifield-1
          EXIT   ! EOF DETECTED
      endif
      if(ierr.lt.-1) EXIT  ! ERROR DETECTED

      YOPER = 'D'
      IERR = 1
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             ZSEC4,JPUNP,INBUFF,JPACK,IWORD,YOPER,IERR)

      IF (IERR.NE.0) STOP 'SORRY: GRIB CODE CONVERSION ERROR'

      IF(ISEC2(2).ne.MNAUF.or.ISEC2(3).ne.MNAUF.or.
     &   ISEC2(4).ne.MNAUF) then
         write(*,*) 'PROGRAMM PRECONVERT - ERROR'
         write(*,*) 'SPECTRAL RESOLUTION DETECTED: ',ISEC2(2)
         write(*,*) '                              ',ISEC2(3)
         write(*,*) '                              ',ISEC2(4)
         write(*,*) 'SPECTRAL RESOLUTION EXPECTED: ',MNAUF
         write(*,*) 'PLEASE CHANGE PARAMETER STATEMENT'
         stop
      endif

      IOFFSET=mod(ifield-1,MSTRIDE)*(ISEC2(12)/2-1)
      IREST=mod(ifield-1,MSTRIDE)

      IF (ISEC1(6) .ne. MPAR(IREST+1)) THEN
        WRITE(*,*) 'READ PARAMETER',ISEC1(6),'EXPECTED',MPAR(IREST+1)
        STOP
      ENDIF

      CXMN(:,IOFFSET+(ifield-1)/MSTRIDE+1)=ZSEC4(1:(MNAUF+1)*(MNAUF+2))

      ENDDO

      IF(IERR .LT. -1) THEN
        WRITE(*,*) 'Error ',ierr,' occured while reading ',FILENAME 
        STOP
      ENDIF

      CALL PBCLOSE(LUNIT,IERR)

      IF(IFIELD.GT.MLEVEL) THEN
         write(*,*) 'PROGRAMM PRECONVERT - ERROR'
         write(*,*) 'NUMBER OF VERTICAL LEVELS EXPECTED: ',mlevel
         write(*,*) 'TRIED TO READ MORE LEVELS ...'
         stop
      endif

!      IF(PRESENT(A) .AND. PRESENT(B)) THEN
        IF(ISEC2(12)/2-1 .ne. MAXLEV) THEN 
          WRITE(*,*) 'FATAL: Number of model levels',
     *ISEC2(12)/2-1,' does not agree with', MLEVEL,' in namelist'
          STOP
        ENDIF
        A=ZSEC2(11:11+MAXLEV)
        B=ZSEC2(11+MAXLEV+1:11+2*MAXLEV+1)
!      ENDIF

      END SUBROUTINE READSPECTRAL

      END MODULE RWGRIB
